
/**
 * 表定义
 * @param {*} tbBuilder 表构造类
 * @param {*} DataTypes 数据类型
 * @returns {*} 对象定义
 */
function tableDefine(tbBuilder, DataTypes) {
  // 测试表
  return tbBuilder.define('demo_table_xjz', {
    // 编号
    jid: {
      type: DataTypes.BIGINT,
      primaryKey: true,
      allowNull: false,
    },
    // 类型
    jtype: {
      type: DataTypes.INTEGER,
      allowNull: true,
      defaultValue:123,
    },
    // 名称
    jname: {
      type: DataTypes.STRING(100),
      allowNull: true,
      defaultValue:"xxxx",
    },
    // 时间
    jtime: {
      type: DataTypes.DATE,
      allowNull: false,
    }
  }, {
      // 建立索引
      indexes: [
        {
          unique: false, // 是否为唯一主键
          fields: ['jtime'], // 索引字段
        },
      ],

      // 原始数据
      dataSql: [
        {
          jid:1,
          jtime:'2018-12-20 09:31:01'
        },
        {
          jid:2,
          jtime: new Date()
        },
        {
          jid:3,
          jtime:'2018-12-20 09:31:02'
        },
       
      ],

      tableName: 'demo_table_xjz', // 表名
      timestamps: false, // 增加时间戳
    });
}

module.exports = tableDefine;




