'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
const process = require("process");
/**
 * 调试开关
 */
var useDebug = (process.env.DEBUG || process.env.JDEBUG) ? true : false;
/**
 * 基础工具
 */
const jbase_utils = require("./lib/jbase_utils");
exports.jbase_utils = jbase_utils;
const jbase_utils_1 = require("./lib/jbase_utils");
exports.sleep = jbase_utils_1.sleep;
exports.seqDo = jbase_utils_1.seqDo;
exports.multiDo = jbase_utils_1.multiDo;
exports.unionObj = jbase_utils_1.unionObj;
exports.equalObj = jbase_utils_1.equalObj;
exports.getRndInt = jbase_utils_1.getRndInt;
exports.getJstamp = jbase_utils_1.getJstamp;
exports.getId = jbase_utils_1.getId;
exports.getNowDate = jbase_utils_1.getNowDate;
exports.chkInjection = jbase_utils_1.chkInjection;
exports.valueEqual = jbase_utils_1.valueEqual;
exports.isEmptyObj = jbase_utils_1.isEmptyObj;
/**
 * 类型工具
 */
const jtype_utils = require("./lib/jtype_utils");
exports.jtype_utils = jtype_utils;
const jtype_utils_1 = require("./lib/jtype_utils");
exports.getString = jtype_utils_1.getString;
exports.getNumber = jtype_utils_1.getNumber;
exports.getInt = jtype_utils_1.getInt;
exports.getBool = jtype_utils_1.getBool;
exports.getArray = jtype_utils_1.getArray;
exports.getDate = jtype_utils_1.getDate;
exports.isYieldFun = jtype_utils_1.isYieldFun;
exports.toMoneyInt = jtype_utils_1.toMoneyInt;
exports.intMoneyToStr = jtype_utils_1.intMoneyToStr;
exports.toMoneyStr = jtype_utils_1.toMoneyStr;
/**
 * json工具
 */
const json_utils = require("./lib/json_utils");
exports.json_utils = json_utils;
const json_utils_1 = require("./lib/json_utils");
exports.jsonTrim = json_utils_1.jsonTrim;
/**
 * 网络工具
 */
const jnet_utils = require("./lib/jnet_utils");
exports.jnet_utils = jnet_utils;
/**
 * 多语言工具
 */
const jlng = require("./lib/jlng");
exports.jlng = jlng;
const Jlng = require("./lib/jlng");
exports.Jlng = Jlng;
/**
 * 多语言工具2
 */
const tlng = require("./lib/tlng");
exports.tlng = tlng;
const tlng_1 = require("./lib/tlng");
exports.t = tlng_1.t;
/**
 * 加密解密工具
 */
const jdocode = require("./lib/jdocode");
exports.jdocode = jdocode;
const jdocode_1 = require("./lib/jdocode");
exports.getUUID = jdocode_1.getUUID;
/**
 * 常用工具类
 */
var jutils = {
    sleep: jbase_utils.sleep,
    seqDo: jbase_utils.seqDo,
    unionObj: jbase_utils.unionObj,
    equalObj: jbase_utils.equalObj,
    getTemplateStr: jbase_utils.getTemplateStr,
    getRndInt: jbase_utils.getRndInt,
    jsonTrim: json_utils.jsonTrim,
    getUUIDHexStr: jdocode.getUUIDHexStr,
    getString: jtype_utils.getString,
    getNumber: jtype_utils.getNumber,
    getInt: jtype_utils.getInt,
    getBool: jtype_utils.getBool,
    getArray: jtype_utils.getArray,
    getDate: jtype_utils.getDate
};
exports.jutils = jutils;
/**
 * 系统错误码定义
 */
const jerror_type = require("./lib/jerror_type");
exports.jerror_type = jerror_type;
/**
 * 系统错误码定义
 */
const JERR_S = require("./lib/jerror_type");
exports.JERR_S = JERR_S;
const JERR = require("./lib/jerror_type");
exports.JERR = JERR;
const ERR = require("./lib/jerror_type");
exports.ERR = ERR;
/**
 * 日志工具
 */
const jlog = require("./lib/jlog");
exports.jlog = jlog;
/**
 * 日志工具
 */
const Jlog = require("./lib/jlog");
exports.Jlog = Jlog;
/**
 * 日志工具(扩展)
 */
const jlog_utils = require("./lib/jlog_utils");
exports.jlog_utils = jlog_utils;
/**
 * co扩展
 */
const jco = require("./lib/jco");
exports.jco = jco;
/**
 * 模块批量载入工具
 */
const jmod_loader = require("./lib/jmod_loader");
exports.jmod_loader = jmod_loader;
/**
 * 信号工具
 */
const jsig_utils = require("./lib/jsig_utils");
exports.jsig_utils = jsig_utils;
const jsig_utils_1 = require("./lib/jsig_utils");
exports.sigWait = jsig_utils_1.sigWait;
exports.sigAck = jsig_utils_1.sigAck;
exports.autoTimeoutRst = jsig_utils_1.autoTimeoutRst;
exports.autoTimeoutClear = jsig_utils_1.autoTimeoutClear;

/**
 * 文件系统工具
 */
const jfile_utils = require("./lib/jfile_utils");
exports.jfile_utils = jfile_utils;
/**
 * 返回处理工具
 */
const jret_utils = require("./lib/jret_utils");
exports.jret_utils = jret_utils;
const jret_utils_1 = require("./lib/jret_utils");
exports.getStdBody = jret_utils_1.getStdBody;
exports.getRetObj = jret_utils_1.getRetObj;
exports.getPageRet = jret_utils_1.getPageRet;
/**
 * C++扩展Addon
 */
const JaAddon = require("./lib/JaAddon");
exports.JaAddon = JaAddon;
/**
 * Redis本地版
 */
const JaRedisLocal = require("./lib/JaRedisLocal");
exports.JaRedisLocal = JaRedisLocal;
/**
 * 测试工具
 */
const jtest_utils = require("./lib/jtest_utils");
exports.jtest_utils = jtest_utils;
/**
 * xml工具
 */
try {
    const jxml_utils = require("./lib/jxml_utils");
    exports.jxml_utils = jxml_utils;
}
catch (error) {
    if (useDebug)
        console.error("Not Load jxml_utils, loss module: xml2js");
}
/**
 * auth工具
 */
try {
    const jauth_utils = require("./lib/jauth_utils");
    exports.jauth_utils = jauth_utils;
}
catch (error) {
    if (useDebug)
        console.error("Not Load jauth_utils, loss module: jsonwebtoken");
}
/**
 * http工具
 */
try {
    const JaHttpUtils = require("./lib/JaHttpUtils");
    exports.JaHttpUtils = JaHttpUtils;
    exports.jhttp_utils = new JaHttpUtils();
}
catch (error) {
    if (useDebug)
        console.error("Not Load jhttp_utils, loss module: request");
}
/**
 * 消息队列
 */
try {
    const JaAmqp = require("./lib/JaAmqp");
    exports.JaAmqp = JaAmqp;
    const JaPublisher = require("./lib/amqp_utils/JaPublisher");
    exports.JaPublisher = JaPublisher;
    const JaSubscriber = require("./lib/amqp_utils/JaSubscriber");
    exports.JaSubscriber = JaSubscriber;
}
catch (error) {
    if (useDebug)
        console.error("Not Load JaAmqp, loss module: amqp");
}
/**
 * 高并发redis
 */
try {
    const JaRedis = require("./lib/JaRedis");
    exports.JaRedis = JaRedis;
}
catch (error) {
    if (useDebug)
        console.error("Not Load JaRedis, loss module: redis");
}
/**
 * 高并发ioRedis
 */
try {
    const JaIoRedis = require("./lib/JaIoRedis");
    exports.JaIoRedis = JaIoRedis;
}
catch (error) {
    if (useDebug)
        console.error("Not Load JaIoRedis, loss module: ioredis");
}
/**
 * 数据库封装类Sequelize
 */
try {
    const JaDb = require("./lib/JaDbSequelize");
    exports.JaDb = JaDb;
    const JaDbSequelize = require("./lib/JaDbSequelize");
    exports.JaDbSequelize = JaDbSequelize;
}
catch (error) {
    if (useDebug)
        console.error("Not Load JaDb/JaDbSequelize, loss module: sequelize [tedious|mysql2|pg pg-hstore],ps:xp not support");
}
/**
 * 数据库封装类Knex
 */
try {
    const JaDbKnex = require("./lib/JaDbKnex");
    exports.JaDbKnex = JaDbKnex;
}
catch (error) {
    if (useDebug)
        console.error("Not Load JaDbKnex, loss module: knex [mssql|mysql2|pg pg-query-stream|oracledb],ps:xp not support");
}
