'use strict';

import process = require('process');

/**
 * 调试开关
 */
var useDebug = (process.env.DEBUG || process.env.JDEBUG) ? true : false;

/**
 * 基础工具
 */
import jbase_utils = require('./lib/jbase_utils');
export { jbase_utils };

import { sleep, seqDo, multiDo, unionObj, equalObj, getRndInt, getJstamp, getId, getNowDate, chkInjection, valueEqual, isEmptyObj } from './lib/jbase_utils';
export { sleep, seqDo, multiDo, unionObj, equalObj, getRndInt, getJstamp, getId, getNowDate, chkInjection, valueEqual, isEmptyObj };


/**
 * 类型工具
 */
import jtype_utils = require('./lib/jtype_utils');
export { jtype_utils };

import { getString, getNumber, getInt, getBool, getArray, getDate, isYieldFun, toMoneyInt, intMoneyToStr, toMoneyStr } from './lib/jtype_utils';
export { getString, getNumber, getInt, getBool, getArray, getDate, isYieldFun, toMoneyInt, intMoneyToStr, toMoneyStr }


/**
 * json工具
 */
import json_utils = require('./lib/json_utils');
export { json_utils };

import { jsonTrim } from './lib/json_utils';
export { jsonTrim };

/**
 * 网络工具
 */
import jnet_utils = require('./lib/jnet_utils');
export { jnet_utils };

/**
 * 多语言工具
 */
import jlng = require('./lib/jlng');
import Jlng = require('./lib/jlng');
export { jlng, Jlng };

/**
 * 多语言工具2
 */
import tlng = require('./lib/tlng');
import { t } from './lib/tlng';
export { tlng, t };

/**
 * 加密解密工具
 */
import jdocode = require('./lib/jdocode');
export { jdocode };

import { getUUID } from './lib/jdocode';
export { getUUID };


/**
 * 常用工具类
 */
var jutils = {
    sleep: jbase_utils.sleep,
    seqDo: jbase_utils.seqDo,
    unionObj: jbase_utils.unionObj,
    equalObj: jbase_utils.equalObj,
    getTemplateStr: jbase_utils.getTemplateStr,
    getRndInt: jbase_utils.getRndInt,

    jsonTrim: json_utils.jsonTrim,

    getUUIDHexStr: jdocode.getUUIDHexStr,

    getString: jtype_utils.getString,
    getNumber: jtype_utils.getNumber,
    getInt: jtype_utils.getInt,
    getBool: jtype_utils.getBool,
    getArray: jtype_utils.getArray,
    getDate: jtype_utils.getDate
};
export { jutils };

/**
 * 系统错误码定义
 */
import jerror_type = require('./lib/jerror_type');
export { jerror_type };

/**
 * 系统错误码定义
 */
import JERR_S = require('./lib/jerror_type');
import JERR = require('./lib/jerror_type');
import ERR = require('./lib/jerror_type');
export { JERR_S, JERR, ERR };

/**
 * 日志工具
 */
import jlog = require('./lib/jlog');
export { jlog };

/**
 * 日志工具
 */
import Jlog = require('./lib/jlog');
export { Jlog };

/**
 * 日志工具(扩展)
 */
import jlog_utils = require('./lib/jlog_utils');
export { jlog_utils };

/**
 * co扩展
 */
import jco = require('./lib/jco');
export { jco };

/**
 * 模块批量载入工具
 */
import jmod_loader = require('./lib/jmod_loader');
export { jmod_loader };

/**
 * 信号工具
 */
import jsig_utils = require('./lib/jsig_utils');
export { jsig_utils };
import { sigWait, sigAck, autoTimeoutRst, autoTimeoutClear } from './lib/jsig_utils';
export { sigWait, sigAck, autoTimeoutRst, autoTimeoutClear };

/**
 * 文件系统工具
 */
import jfile_utils = require('./lib/jfile_utils');
export { jfile_utils };

/**
 * 返回处理工具
 */
import jret_utils = require('./lib/jret_utils');
export { jret_utils };
import { getStdBody, getRetObj, getPageRet } from './lib/jret_utils';
export { getStdBody, getRetObj, getPageRet };

/**
 * C++扩展Addon
 */
import JaAddon = require('./lib/JaAddon');
export { JaAddon };


/**
 * Redis本地版
 */
import JaRedisLocal = require('./lib/JaRedisLocal');
export { JaRedisLocal };

/**
 * 测试工具
 */
import jtest_utils = require('./lib/jtest_utils');
export { jtest_utils };

/**
 * xml工具
 */
import jxml_utils = require('./lib/jxml_utils');
export { jxml_utils };
try {
} catch (error) {
    if (useDebug) console.error("Not Load jxml_utils, loss module: xml2js");
}

/**
 * auth工具
 */
import jauth_utils = require('./lib/jauth_utils');
export { jauth_utils };
try {
} catch (error) {
    if (useDebug) console.error("Not Load jauth_utils, loss module: jsonwebtoken");
}

/**
 * http工具
 */
import JaHttpUtils = require('./lib/JaHttpUtils');
export var jhttp_utils = new JaHttpUtils();
export { JaHttpUtils };
try {
} catch (error) {
    if (useDebug) console.error("Not Load jhttp_utils, loss module: request");
}

/**
 * 消息队列
 */
import JaAmqp = require('./lib/JaAmqp');
import JaPublisher = require('./lib/amqp_utils/JaPublisher');
import JaSubscriber = require('./lib/amqp_utils/JaSubscriber');
export { JaAmqp, JaPublisher, JaSubscriber };
try {
} catch (error) {
    if (useDebug) console.error("Not Load JaAmqp, loss module: amqp");
}

/**
 * 高并发redis
 */
import JaRedis = require('./lib/JaRedis');
export { JaRedis };
try {
} catch (error) {
    if (useDebug) console.error("Not Load JaRedis, loss module: redis");
}

/**
 * 高并发ioRedis
 */
import JaIoRedis = require('./lib/JaIoRedis');
export { JaIoRedis };
try {
} catch (error) {
    if (useDebug) console.error("Not Load JaIoRedis, loss module: ioredis");
}

/**
 * 数据库封装类Sequelize
 */
import JaDb = require('./lib/JaDbSequelize');
import JaDbSequelize = require('./lib/JaDbSequelize');
export { JaDb, JaDbSequelize };
try {
} catch (error) {
    if (useDebug) console.error("Not Load JaDb/JaDbSequelize, loss module: sequelize [tedious|mysql2|pg pg-hstore],ps:xp not support");
}

/**
 * 数据库封装类Knex
 */
import JaDbKnex = require('./lib/JaDbKnex');
export { JaDbKnex };
try {
} catch (error) {
    if (useDebug) console.error("Not Load JaDbKnex, loss module: knex [mssql|mysql2|pg pg-query-stream|oracledb],ps:xp not support");
}
