function isNullOrUndefined(obj) {
    return (obj === undefined || obj === null) ? true : false;
}

function isEmptyObj(obj) {
    return (obj === undefined || obj === null || Object.getOwnPropertyNames(obj).length === 0) ? true : false;
}

function isEmptyStr(str) {
    return (str === undefined || str === null || str === "") ? true : false;
}

function isEmptyArray(array) {
    return ((Object.prototype.toString.call(array) === '[object Array]') && array.length > 0) ? false : true;
}

function isArray(obj) {
    return Object.prototype.toString.call(obj) === '[object Array]';
}

function isNumber(obj) {
    return Object.prototype.toString.call(obj) === '[object Number]';
}

function isInt(obj) {
    if (Object.prototype.toString.call(obj) !== '[object Number]') {
        return false;
    }

    return parseInt(obj, 10) === obj;
}

function isBoolean(obj) {
    return Object.prototype.toString.call(obj) === '[object Boolean]';
}

function isString(obj) {
    return Object.prototype.toString.call(obj) === '[object String]';
}

function isNull(obj) {
    return Object.prototype.toString.call(obj) === '[object Null]';
}

function isUndefined(obj) {
    return Object.prototype.toString.call(obj) === '[object Undefined]';
}

function isObject(obj) {
    return Object.prototype.toString.call(obj) === '[object Object]';
}

function isFunction(obj) {
    return Object.prototype.toString.call(obj) === '[object Function]';
}

function checkType(obj, Type) {
    return obj instanceof Type;
}

exports.isNullOrUndefined   = isNullOrUndefined;
exports.isEmptyObj          = isEmptyObj;
exports.isEmptyStr          = isEmptyStr;
exports.isEmptyArray        = isEmptyArray;
exports.isArray             = isArray;
exports.isNumber            = isNumber;
exports.isInt               = isInt;
exports.isBoolean           = isBoolean;
exports.isString            = isString;
exports.isNull              = isNull;
exports.isUndefined         = isUndefined;
exports.isObject            = isObject;
exports.isFunction          = isFunction;
exports.checkType           = checkType;
