"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parse = parse;
exports.stringify = stringify;
var xml2js = require('xml2js');
var jsonBuilder = new xml2js.Builder({ renderOpts: { pretty: false }, cdata: true });
/**
 * var a = yield base_parts.jxml_utils.parse("<xml><return_code><![CDATA[FAIL]]></return_code><return_msg><![CDATA[post数据为空]]></return_msg></xml>");
 * var b = base_parts.jxml_utils.stringify(a);
 *
 * explicitArray:数组存储方式
 * ignoreAttrs:忽略属性
 */
/**
 * 解析xml到对象(注意:返回的是异步Promise)
 * @param xmlStr xml字符串对象
 * @param opt 选项
 * @returns 返回对象
 */
function parse(xmlStr, opt) {
    // // 默认选项
    // var curOpt = { explicitArray: false, ignoreAttrs: true };
    // jbase_utils.unionObj(curOpt, opt);
    return new Promise((resolve, reject) => {
        try {
            var xmlParser = new xml2js.Parser(opt);
        }
        catch (error) {
            return reject(error);
        }
        xmlParser.parseString(xmlStr, function (err, result) {
            return err ? reject(err) : resolve(result);
        });
    }); // End Promise
}
/**
 * 解析对象到xml字符串(注意:返回是字符串,没有异步Promise)
 * @param obj 对象
 * @param opt 选项
 * @returns 返回xml字符串
 */
function stringify(obj, opt) {
    var myBuild = jsonBuilder;
    if (opt) {
        myBuild = new xml2js.Builder(opt);
    }
    return myBuild.buildObject(obj);
}
