'use strict';

var assert = require('assert'); // 断言函数
var jutils = require('../index');

var JaDb = jutils.JaDb;
var JaDbKnex = jutils.JaDbKnex;

describe("JaDb", function () {
    it('base', function () {
        return jutils.jco(async () => {


            //var db = new JaDb();
            var db = new JaDbKnex();
            await db.init({
                timeSpTable: 1,
                logging: 2,
                opField: true,
                fieldFormat: 1,

                // timezone:'+01:00',

                // "dialect": "mssql", 
                // "database": "master", // 数据库
                // "host": "10.0.96.8", // 主机及实例名
                // "user": "sa", // 用户名
                // "port": 49157,
                // "password": "weds123!@#", // 密码

                // "dialect": "mssql",
                // "database": "master", // 数据库
                // "host": "127.0.0.1", // 主机及实例名
                // "user": "sa", // 用户名
                // "port": 59157,
                // "password": "471", // 密码

                "dialect": "postgres",
                "database": "postgres", // 数据库
                "host": "127.0.0.1", // 主机
                "port": 5432, // 端口
                "user": "postgres", // 用户名
                "password": "", // 密码

                // "dialect": "mysql",
                // "database": "aa", // 数据库
                // "host": "127.0.0.1", // 主机
                // "port": 3306, // 端口
                // "user": "root", // 用户名
                // "password": "", // 密码

                // "dialect": "oracledb",
                // "database": "orcl", // 数据库
                // "host": "10.0.96.10", // 主机
                // "port": 1521, // 端口
                // "user": "system", // 用户名
                // "password": "123456", // 密码
                // "initOracleCfg": {
                //     "libDir": "C:\\instantclient_21_3", // lib路径:http://oracle.github.io/node-oracledb/
                // },

                // "dialect": "mssql",
                // "database": "scm_main_0815", // 数据库
                // "host": "10.1.0.21", // 主机及实例名
                // "user": "sa", // 用户名
                // "port": 1433,
                // "password": "123", // 密码

            });

            // var xx = yield db.q(`select isnull(user_lx,0) user_lx,COUNT(a.user_serial) userCounts from jview_user_list a 
            // inner join dt_user b on a.user_serial=b.user_serial and b.user_type<51 and a.jid=:jid
            // group by ISNULL(user_lx,0)`,{
            //     jid:"123"
            // })

            // 测试超时
            //var timOut = yield db.db.raw('mytimeout') //.timeout(10*60*1000,{})

            // 同步表
            await db.loadModel("./db_table", {});

            // 插入
            var t1 = await db.insert("demo_table_xjz", {
                jid: jutils.getId(),
                jtype: 11112,
                jname: 'nnnnn2',
                jtime: new Date()
            });

            // 修改
            var t2 = await db.update("demo_table_xjz",
                {
                    jtype: 11113,
                    jname: 'nnnnn3',
                    jtime: new Date()
                },
                "jid > :jid",
                {
                    jid: 1
                });


            // 事物操作
            await db.t(async (t, q) => {

                // 删除
                var t3 = await db.delete("demo_table_xjz",
                    "jid = :jid",
                    {
                        jid: 1,
                        transaction: t // 使用transaction也能达到事物效果
                    });

                // 通过insertVal插入
                await q({
                    sql: "insert into demo_table_xjz",
                    insertVal: [
                        {
                            jid: jutils.getId(),
                            jtype: 1111,
                            jname: 'nnnnn',
                            jtime: new Date()
                        }
                    ]
                });

                // 原生插入,不推荐
                await q("insert into demo_table_xjz(jid, jtype, jname, jtime) VALUES (:jid,1111,'nnnnn',:date)", {
                    date: new Date(),
                    jid: jutils.getId()
                });

                // 通过updateVal更新
                await q({
                    sql: "update demo_table_xjz where jid>:jid",
                    opUser: "方䕒敏,蔡綉英",
                    updateVal: {
                        jtype: 222,
                        jname: '这是언어これは🌮🌽🧑🏽🗡𓀫🤬👩🏼👩🏿🥟🍻🥠🔪🌯'
                    }
                }, {
                    jid: 1,
                });

            });

            // 分页查询
            var aa = await db.select({
                sql: "* from demo_table_xjz where jtime >:dateTime",
                pageOpt: {
                    pageSize: 5,
                    current: 1,
                    needTotal: true
                },
                order: "jid desc",
                andWhere: [
                    {
                        field: "jid",
                        op: ">",
                        value: 1
                    },
                    {
                        field: "jid",
                        op: "is not null",
                        value: ""
                    }
                ],
                // // 有这个配置将使用流方式
                // selectStream: {
                //     highWaterMark: 1000
                // },
                timeFmt: 2,
                fieldFormat: 1
            }, {
                dateTime: '2018-11-21 17:49:22'
            }
                ,
                function* (row, index, allRows) {
                    console.log(index);
                    yield jutils.sleep(10);
                }
            );


            console.log();


            // if (tokenObj.a !== 123 || tokenObj.b !== "456") {
            //     assert.fail("equalObj");
            // }

        });
    });
});

