'use strict';

var assert = require('assert'); // 断言函数
var jutils = require('../index');

var jlog = jutils.jlog(__filename);
var jhttp_utils = jutils.jhttp_utils;

describe("jhttp_utils", function () {


    // 基础测试
    it('jhttp_utils', function () {
        return jutils.jco(function* () {
            // // 打开日志开关
            // jlog.setEnable(true, "JaHttpUtils");

            // 请求结果过滤器
            yield jutils.jhttp_utils.setRetFilter(function (err, flObj) {
                console.log("jhttp_utils RetFilter:", flObj.url);
            });

            // 请求测试
            try {
                var retStdBody = yield jutils.jhttp_utils.postJson("http://reg.weds.com.cn:6606/soft_reg/reg_info", { "pcKey": "1_1znJ2hDWjWbWFchw34214w" }, {
                    needResHeader: true,
                    randomUrl: true
                });
                yield jutils.jhttp_utils.setFirstFilter((mode, url, inOpt) => {
                    console.log();
                })

                // 后置过滤器
                yield jutils.jhttp_utils.setLastFilter((mode, urlStr, inObj, retObj, res) => {
                    console.log();
                })

                retStdBody = yield jutils.jhttp_utils.postJson("http://reg.weds.com.cn:6606/soft_reg/reg_info", { "pcKey": "1_1znJ2hDWjWbWFchw34214w" }, {
                    stdBody: true
                });

                retStdBody = yield jutils.jhttp_utils.postJson("http://reg.weds.com.cn:6606/soft_reg/reg_info", { "pcKey": "1_1znJ2hDWjWbWFchw34214w" }, {
                    needResHeader: true,
                    encoding: "buffer"
                });

                // 测试替换URL
                console.log("jhttp_utils 1");
                yield jutils.jhttp_utils.setFirstFilter((mode, url, inOpt) => {
                    console.log("jhttp_utils 2.1");
                    return "https://www.baidu.com"
                });
                console.log("jhttp_utils 2");
                yield jutils.jhttp_utils.downloadFile("https://dldir1.qq.com/qqfile/qq/PCTIM2.3.0/20979/TIM2.3.0.20979.exe", "./temp/baidu.txt");
                console.log("jhttp_utils 2.2");
                yield jutils.jhttp_utils.setFirstFilter(null);
                console.log("jhttp_utils 3");

                // 测试下载
                yield jutils.jhttp_utils.downloadFile("https://www.baidu.com/img/baidu_jgylogo3.gif", "./temp/2.gif", { noError: true });
                console.log("jhttp_utils 4");

                // 进度下载
                // var t_dwObj;
                // var dwRet = yield jutils.jhttp_utils.downloadFile("http://zdfans7.com/GoogleChrome_791.zip", "./temp/2.tmp", {
                //     noError: true,
                //     needResHeader: true,
                //     randomUrl: true
                // }, (res, dwObj) => {
                //     t_dwObj = dwObj;
                //     // 进度
                //     setInterval(() => {
                //         jlog.info(dwObj)
                //     }, 1000);

                //     // 停止
                //     setTimeout(() => {
                //         dwObj.about()
                //     }, 5000);

                //     console.log();
                //     //return false
                // });
                // console.log("jhttp_utils 0");

            } catch (error) {
                assert.fail("错误");
            }

            try {
                var ret;

                jhttp_utils.setErrCbFun(function (mode, errCode, reqObj, retObj, stateCode, error) {
                    console.log();
                    //return 1; // 不抛错,1ms后重试,返回非数字或不返回则抛出错误
                })

                try {
                    ret = yield jhttp_utils.postWww("http://212.222.222.222/index.php", { x1: 123 }, { qs: { x2: "aaa" }, timeout: 5000 });
                } catch (error) {
                    console.log("以上为错误测试");
                }
                // ret = yield jhttp_utils.getData("http://www.weds.com.cn/index.php?x1=123", { x2: "aaa" });
                // ret = yield jhttp_utils.postJson("http://www.weds.com.cn/index.php", { x1: 123 }, { heards: { a: 123 } });
            } catch (error) {
                assert.fail("错误");
            }

            console.log("jhttp_utils ok");

        });
    });

    // // 并发测试
    // it('multiDo', function () {
    //        return jutils.jco(function*() {

    //         try {
    //             var task = [];

    //             jlog.setEnable(false,"*");

    //             var startTick = Date.now();

    //             for (var index = 0; index < 1000; index++) {

    //                 task.push({
    //                     fun: jutils.jhttp_utils.getData,
    //                     args: [
    //                         "http://127.0.0.1:8888/"
    //                     ],
    //                     thisObj:jutils.jhttp_utils
    //                 });

    //             }


    //             var aa = yield jutils.multiDo(task, 100,1);

    //             var exTick =  Date.now()-startTick;
    //             console.log(exTick);


    //         } catch (error) {
    //             assert.fail("错误");
    //         }

    //     });
    // });


});

