'use strict';

var assert = require('assert'); // 断言函数
var jutils = require('../index');

var jauth_utils = jutils.jauth_utils;

describe("jauth_utils", function () {
    it('base', function () {
        return jutils.jco(function*() {
            var baseStr = jauth_utils.makeBasicAuth("myName", "!@#$%^&*()WERTYUI:sas");
            var baseObj = jauth_utils.getBasicAuth(baseStr);
            if (baseObj.userName !== "myName" || baseObj.passWord !== "!@#$%^&*()WERTYUI:sas") {
                assert.fail("equalObj");
            }

            var tokenStr = jauth_utils.makeJwtTokenStr({a:123,b:"456"},"asdadadxvcdzf");
            var tokenObj = jauth_utils.getJwtTokenObj(tokenStr,"asdadadxvcdzf");
            if (tokenObj.a !== 123 || tokenObj.b !== "456") {
                assert.fail("equalObj");
            }

        });
    });
});

