'use strict';

var assert = require('assert'); // 断言函数
var jutils = require('../index')

var jfile_utils = jutils.jfile_utils;

var fs = require('fs');

describe("jfile_utils", function () {
    it('readByLine', function () {

        return jutils.jco(function* () {

            var ret;

            ret = yield jfile_utils.access("./test/line_text.txt");
            console.log(ret);

            ret = yield jfile_utils.copyFile("./test/line_text.txt", "./temp/aaaaa.txt");
            console.log(ret);

            ret = yield jfile_utils.moveFile("./temp/aaaaa.txt", "./temp/aaaaa.txt2");
            console.log(ret);


            ret = yield jfile_utils.deleteFile("./temp/aaaaa.txt2");
            console.log(ret);

            ret = yield jfile_utils.mkdir("./temp/testdir");
            console.log(ret);

            ret = yield jfile_utils.mkdir("./temp/testdir/test");
            console.log(ret);

            ret = yield jfile_utils.copyFile("./test/line_text.txt", "./temp/testdir/test/aaaaa.txt");
            console.log(ret);

            ret = yield jfile_utils.deleteFolder("./temp/testdir");
            console.log(ret);

            try {
                yield jfile_utils.readByLine("./test/line_text.txt", function (strBuf, strSize, lineNum) {
                    console.log(`strSize=${strSize},lineNum=${lineNum}`);

                    console.log(strBuf.toString("utf8", 0, strSize));
                });

            } catch (error) {
                assert.fail("错误");
            }

            try {
                var fd = yield jfile_utils.open("./temp/1.txt", "w");

                yield jfile_utils.write(fd, "12345678");
                yield jfile_utils.write(fd, "abcdefgh", 1);

                var wBuf = new Buffer("666");
                yield jfile_utils.write(fd, wBuf, 1, 2);

                yield jfile_utils.close(fd);

                fd = yield jfile_utils.open("./temp/1.txt", "r");

                var myBuf = new Buffer(1000);
                var getLen = yield jfile_utils.read(fd, myBuf, 0, myBuf.length);

                yield jfile_utils.close(fd);


                console.log(myBuf.toString("utf8", 0, 0 + getLen));

            } catch (error) {
                assert.fail("错误");
            }
            // console.time("1111")
            // var stFd = yield jfile_utils.openSw("./temp/w1.txt");
            // for (var index = 0; index < 100003; index++) {
            //     yield jfile_utils.WriteSw(stFd, index+"a111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111\n");
            // }

            // yield jfile_utils.CloseSw(stFd);
            // console.log(JSON.stringify(fs.statSync("./temp/w1.txt")));
            // console.timeEnd("1111")

            // console.time("2222")
            // var fd = yield jfile_utils.open("./temp/1.txt", "w");
            // for (var index = 0; index < 100003; index++) {
            //     yield jfile_utils.write(fd, index+"a111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111\n");
            // }
            // yield jfile_utils.close(fd);
            // console.log(JSON.stringify(fs.statSync("./temp/1.txt")));

            // console.timeEnd("2222")


            console.log("finish")

        });
    });
});

