'use strict';

var assert = require('assert'); // 断言函数
var jutils = require('../index');

describe("jutils", function () {
    it('jutils', function () {
        return jutils.jco(function* () {

            var ret;
            ret = jutils.getStdBody({ code: 0 });
            ret = jutils.getStdBody({ code: 0, msg: "" });
            ret = jutils.getStdBody({ code: 0, msg: "", data: {} });
            ret = jutils.getStdBody({ code: 0, msg: "", data: null });
            ret = jutils.getStdBody({ code: 0, msg: "", data: null });
            ret = jutils.getStdBody(null, { a: 123 });
            ret = jutils.getStdBody(1, null);
            ret = jutils.getStdBody("", 66);
            try {
                ret = jutils.getStdBody({ code: 10 });
            } catch (error) {
                console.log();
            }

            yield jutils.sleep(1);

            var x0 = jutils.getArray([1]);
            var x1 = jutils.getArray(111, [1]);
            var x2 = jutils.getArray([111, 222], [1], 2);
            var x3 = jutils.getArray([111, 222], [1], 3);
            if (x0.length !== 1 || x1.length !== 1 || x2.length !== 2 || x3.length !== 1) {
                assert.fail("getArray");
            }

            var x4 = jutils.getBool(false);
            var x5 = jutils.getBool(true);
            var x6 = jutils.getBool(111);

            if (x4 !== false || x5 !== true || x6 !== undefined) {
                assert.fail("getBool");
            }

            var a1 = { b: 1, c: 2, d: { e: "3" }, x: [1, "2"] };
            var a2 = { b: 1, c: "2", d: { e: "31" }, x: [1, "2"] };
            var eq = jutils.equalObj(a1, a2, ["e", "c"]);
            if (!eq) {
                assert.fail("equalObj");
            }

            var x7 = jutils.getDate(new Date());
            var x8 = jutils.getDate(123);
            var x9 = jutils.getDate(new Date(), null, 2);
            var x10 = jutils.getDate(new Date(), null, 3);

            var timeOffset = (new Date('2000-1-1 0:0:0')).getTime();
            var newTime = jutils.getDate(new Date(timeOffset + (60 * 1000)), undefined, 2);




            console.log("finish");

        });
    });
});

